"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class AnalysisPanel(ProtocolElement):
    """
    An analysis panel
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "panelName",
        "specificDisease",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import participant as participant_1_5_0

        return {
            "org.gel.models.participant.avro.AnalysisPanel": participant_1_5_0.AnalysisPanel,
        }

    __slots__ = [
        "panelName",
        "specificDisease",
        "multipleGeneticOrigins",
        "panelId",
        "panelVersion",
        "reviewOutcome",
    ]

    def __init__(
        self,
        panelName,
        specificDisease,
        multipleGeneticOrigins=None,
        panelId=None,
        panelVersion=None,
        reviewOutcome=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_5_0.AnalysisPanel model.

        :param panelName:
            The name of the panel
        :type panelName: str
        :param specificDisease:
            The specific disease that a panel tests
        :type specificDisease: str
        :param multipleGeneticOrigins:
            Deprecated
        :type multipleGeneticOrigins: None | str
        :param panelId:
            Id of the panel
        :type panelId: None | str
        :param panelVersion:
            The version of the panel
        :type panelVersion: None | str
        :param reviewOutcome:
            Deprecated
        :type reviewOutcome: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.0"
